#include <midasplayer.h>
#include <conio.h>
#include <iostream.h>

void Help()
 {
  cout << " mplay - MIDAS based module player by lp 1997 \n";
  cout << "----------------------------------------------\n\n";
  cout << "Available commands:\n";
  cout << " exit, list, add [fn], state, help, stop, play, pause\n";
  cout << " resume, info, load, free, next, previous, random, jump [n]\n";
  cout << "\n";
 }

void main()
 {
  lpMIDASPlayer mplay;

  mplay.ReadPlayList("F:\\DATA\\EVERYTHING.MPL");
  mplay.PlayNextModule();
  bool exit = 0;

  Help();
  cout << "\n> ";
  while (!exit)
   {
    mplay.UpdateSongInfo();
    if (kbhit())
     {
      string cmdln;

      getline(cin, cmdln);

      string cmd;
      if (cmdln.find(" ")== NPOS)
       cmd = cmdln;
      else
       cmd = string(cmdln, 0, cmdln.find(" "));

      if (cmd == "list")
       {
        cout << "+ Listing playlist:\n";
        lpMIDASPlayer::lpDMMListIterator i(*mplay.GetDMMList());
        int scroll = 0;
        while (i)
         {
          if (mplay.GetTrackFile() == i.Current()->GetFileName())
           {
            textcolor(15);
            cout << " >";
           }
          else
           {
            textcolor(7);
            cout << "  ";
           }
          cout << mplay.GetDMMList()->Find(i.Current()) <<
                  ". " << i.Current()->GetFileName() <<
                  "\" - \"" << i.Current()->GetTrackName() << "\"\n";
          i++;
          scroll++;
          if (scroll == 23)
           {
            getch();
            scroll = 0;
           }
         }
        cout << " " << mplay.GetDMMList()->GetItemsInContainer() << " entries in playlist!\n";
       }
      else if (cmd == "help")
       {
        Help();
       }
      else if (cmd == "retr")
       {
        cout << "+ Please wait, while retrieving song information.\n";
        lpMIDASPlayer::lpDMMListIterator i(*mplay.GetDMMList());
        char s[8] = "|\-/|\-/";
        int pos = 0;
        while (i)
         {
          i.Current()->RetrieveSongInfo();
          i++;
          cout << s[pos] << "\r";
          pos++;
          if (pos == 8) pos = 0;
         }
        cout << "\n";
       }
      else if (cmd == "state")
       {
        if (mplay.GetState(lpMIDASPlayer::Loaded)) cout << " [LOADED]";
        if (mplay.GetState(lpMIDASPlayer::Playing)) cout << " [PLAYING]";
        if (mplay.GetState(lpMIDASPlayer::Paused)) cout << " [PAUSED]";
        cout << "\n";
       }
      else if (cmd == "add")
       {
        string fn(cmdln, cmdln.find(" ")+1);
        mplay.AddModule(fn);
        mplay.PlayFile(fn);
        cout << "+ File successfully added!\n";
       }
      else if (cmd == "stop")
       {
        mplay.Stop();
        cout << "+ Playback stopped!\n";
       }
      else if (cmd == "play")
       {
        mplay.Play();
        cout << "+ Playback started!\n";
       }
      else if (cmd == "pause")
       {
        mplay.Pause();
        cout << "+ Playback paused!\n";
       }
      else if (cmd == "resume")
       {
        mplay.Resume();
        cout << "+ Playback resumed!\n";
       }
      else if (cmd == "exit")
       {
        exit = 1;
        cout << "+ Program quitted!\n";
       }
      else if (cmd == "info")
       {
        cout << "+ Song info:\n";
        cout << "  Playlist index: " << mplay.GetTrackIndex() << "\n";
        cout << "  Filename:       " << mplay.GetTrackFile() << "\n";
        cout << "  Trackname:      " << mplay.GetTrackName() << "\n";
        cout << "  Position:       " << (mplay.GetTrackActualPos()+1) << "/" << mplay.GetTrackLength() <<"\n";
        cout << "  Pattern:        " << (mplay.GetTrackActualPattern()+1) << "/" << mplay.GetTrackPatternCount()
             << " [Row: " << mplay.GetTrackActualRow() << "]\n";
        cout << "  Channels:       " << mplay.GetTrackChannelCount() << "\n";
        cout << "  Instrument:     " << mplay.GetTrackInstrumentCount() << "\n";
       }
      else if (cmd == "load")
       {
        string fn(cmdln, cmdln.find(" ")+1);
        mplay.ReadPlayList(fn);
        cout << "+ Playlist successfully loaded!\n";
       }
      else if (cmd == "free")
       {
        mplay.FreePlayList();
        mplay.Unload();
        cout << "+ Playlist successfully freed!\n";
       }
      else if (cmd == "next")
       {
        mplay.PlayNextModule(lpMIDASPlayer::SequentialForward, lpMIDASPlayer::Clip);
        cout << "+ Next track is beeing played!\n";
       }
      else if (cmd == "previous")
       {
        mplay.PlayNextModule(lpMIDASPlayer::SequentialBackward, lpMIDASPlayer::Clip);
        cout << "+ Previous track is beeing played!\n";
       }
      else if (cmd == "random")
       {
        mplay.PlayNextModule(lpMIDASPlayer::Random, lpMIDASPlayer::Clip);
        cout << "+ Randomly selected track is beeing played!\n";
       }
      else if (cmd == "jump")
       {
        string idx(cmdln, cmdln.find(" ")+1);
        mplay.PlayIndex(atoi(idx.c_str()));
        cout << "+ Jumped directly to index " << atoi(idx.c_str()) << "!\n";
       }
      else
       {
        cout << "- Unknown command!\n";
       }
      cout << "\n> ";
     }
   }
 }